
E_MODEL_CREEPY_CATACOMB_DOOR = smlua_model_util_get_id("creepy_catacomb_door_geo")
COL_CREEPY_CATACOMB_DOOR = smlua_collision_util_get("creepy_catacomb_door_collision")

function bhv_creepy_catacomb_door_set_parent(obj)
    local group = (obj.oBehParams >> 24) & 0xFF
    local obj2 = obj_get_first(OBJ_LIST_LEVEL)
    while obj2 ~= nil do
        if get_id_from_behavior(obj2.behavior) == id_bhvCreepyCatacombSwitch then
            local group2 = (obj2.oBehParams >> 24) & 0xFF
            if group == group2 then
                obj.parentObj = obj2
                return
            end
        end
        obj2 = obj_get_next(obj2)
    end
end

function bhv_creepy_catacomb_door_init(obj)
    obj.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    obj.oOpacity = 255

    obj_set_model_extended(obj, E_MODEL_CREEPY_CATACOMB_DOOR)

    obj.oCollisionDistance = 1000
    obj.collisionData = COL_CREEPY_CATACOMB_DOOR

    obj.oAction = (obj.oBehParams >> 16) & 0xFF

    cur_obj_set_home_once()
    bhv_creepy_catacomb_door_set_parent(obj)
end

function bhv_creepy_catacomb_door_loop(obj)
    local m = gMarioStates[0]
    local action_offset = (obj.oBehParams >> 16) & 0xFF
    local speed = 10
    local open_height = obj.oHomeY + 650

    if obj.parentObj ~= nil then
        obj.oAction = (obj.parentObj.oAction + action_offset) % 2
    end

    if obj.oAction == 0 then
        if obj.oPosY > obj.oHomeY then
            obj.oPosY = obj.oPosY - speed
            if obj.oPosY <= obj.oHomeY then
                obj.oPosY = obj.oHomeY
                cur_obj_play_sound_1(SOUND_ENV_BOAT_ROCKING1)
            end
        end
    elseif obj.oAction == 1 then
        if obj.oPosY < open_height then
            if dist_between_objects(obj, m.marioObj) < 2500 then
                cur_obj_play_sound_2(SOUND_ENV_ELEVATOR1)
            end
            obj.oPosY = obj.oPosY + speed
            if obj.oPosY >= open_height then
                obj.oPosY = open_height
                cur_obj_play_sound_1(SOUND_ENV_BOAT_ROCKING1)
            end
        end
    end

    load_object_collision_model()
end

id_bhvCreepyCatacombDoor = hook_behavior(nil, OBJ_LIST_SURFACE, true, bhv_creepy_catacomb_door_init, bhv_creepy_catacomb_door_loop, 'id_bhvCreepyCatacombDoor')
