
E_MODEL_CREEPY_CATACOMB_STATUE = smlua_model_util_get_id("creepy_catacomb_statue_geo")

function bhv_creepy_catacomb_statue_init(obj)
    obj.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    obj.oOpacity = 255
    obj.oTimer = 2
    obj.oAction = 0

    obj.oIntangibleTimer = 0
    obj.oInteractType = INTERACT_IGLOO_BARRIER
    obj_set_hitbox_radius_and_height(obj, 150, 150)

    network_init_object(obj, false, {
        'oHomeX',
        'oHomeY',
        'oHomeZ',
        'oAction',
        'oPrevAction',
        'oTimer',
    })

    obj_set_model_extended(obj, E_MODEL_CREEPY_CATACOMB_STATUE)
end

function bhv_creepy_catacomb_statue_last()
    local obj = obj_get_first(OBJ_LIST_LEVEL)
    while obj ~= nil do
        if get_id_from_behavior(obj.behavior) == id_bhvCreepyCatacombStatue then
            if obj.oAction == 0 then
                return false
            end
        end
        obj = obj_get_next(obj)
    end
    return true
end

function bhv_creepy_catacomb_statue_loop(obj)
    local m = gMarioStates[0]

    if obj.oAction == 0 then
        cur_obj_unhide()
        obj.oIntangibleTimer = 0
        if m ~= nil and m.marioObj ~= nil then
            if (m.action & ACT_FLAG_ATTACKING) ~= 0 and dist_between_objects(obj, m.marioObj) < 250 then
                obj.oAction = 1
                obj.oTimer = 0
                network_send_object(obj, true)
            end
        end
    elseif obj.oAction == 1 then
        cur_obj_hide()
        obj.oIntangibleTimer = 30
        if obj.oTimer == 1 then
            cur_obj_play_sound_1(SOUND_GENERAL_BREAK_BOX)
            spawn_mist_particles_variable(0, 0, 46)
            spawn_triangle_break_particles(30, 138, 3.0, 4)

            if bhv_creepy_catacomb_statue_last() then
                spawn_default_star(obj.oPosX, obj.oPosY + 200, obj.oPosZ)
            else
                obj.oNumLootCoins = 5
                obj_spawn_loot_yellow_coins(obj, 5, 20.0)
            end
        end
    end
end

id_bhvCreepyCatacombStatue = hook_behavior(nil, OBJ_LIST_LEVEL, true, bhv_creepy_catacomb_statue_init, bhv_creepy_catacomb_statue_loop, 'id_bhvCreepyCatacombStatue')
