
E_MODEL_CREEPY_HOUSE_DOOR = smlua_model_util_get_id("creepy_house_door_geo")
COL_CREEPY_HOUSE_DOOR = smlua_collision_util_get("creepy_house_door_collision")

function bhv_creepy_house_door_init(obj)
    obj.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    obj.oOpacity = 255

    obj_set_model_extended(obj, E_MODEL_CREEPY_HOUSE_DOOR)

    obj.oCollisionDistance = 1000
    obj.collisionData = COL_CREEPY_HOUSE_DOOR

    obj.oAction = (obj.oBehParams >> 16) & 0xFF

    cur_obj_set_home_once()

    network_init_object(obj, false, {
        'oHomeX',
        'oHomeY',
        'oHomeZ',
        'oPosY',
        'oAction',
        'oPrevAction',
        'oTimer',
    })
end

function bhv_creepy_house_door_loop(obj)
    local speed = 5
    local open_height = obj.oHomeY + 245
    if obj.oAction == 1 then
        if obj.oPosY < open_height then
            cur_obj_play_sound_2(SOUND_ENV_ELEVATOR1)
            obj.oPosY = obj.oPosY + speed
            if obj.oPosY >= open_height then
                obj.oPosY = open_height
                cur_obj_play_sound_1(SOUND_ENV_BOAT_ROCKING1)
            end
        end
    end

    load_object_collision_model()
end

id_bhvCreepyHouseDoor = hook_behavior(nil, OBJ_LIST_SURFACE, true, bhv_creepy_house_door_init, bhv_creepy_house_door_loop, 'id_bhvCreepyHouseDoor')
