
function bhv_creepy_house_switch_init(obj)
    obj.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    obj.oOpacity = 255
    obj.oTimer = 2

    obj.oIntangibleTimer = 0
    obj.oInteractType = INTERACT_IGLOO_BARRIER
    obj_set_hitbox_radius_and_height(obj, 100, 200)

    obj.oFaceAngleRoll = -0x2500
    obj_set_model_extended(obj, E_MODEL_CREEPY_CATACOMB_SWITCH)
    cur_obj_set_home_once()

    network_init_object(obj, false, {
        'oHomeX',
        'oHomeY',
        'oHomeZ',
        'oAction',
        'oPrevAction',
        'oTimer',
    })
end

function bhv_creepy_house_switch_all_on(obj)
    local group = (obj.oBehParams >> 24) & 0xFF
    local obj2 = obj_get_first(OBJ_LIST_LEVEL)
    while obj2 ~= nil do
        if get_id_from_behavior(obj2.behavior) == id_bhvCreepyHouseSwitch then
            local group2 = (obj2.oBehParams >> 24) & 0xFF
            if group == group2 then
                if obj2.oAction == 0 then
                    return false
                end
            end
        end
        obj2 = obj_get_next(obj2)
    end
    return obj.oAction ~= 0
end

function bhv_creepy_house_switch_open_doors(obj)
    local group = (obj.oBehParams >> 24) & 0xFF
    local obj2 = obj_get_first(OBJ_LIST_SURFACE)
    while obj2 ~= nil do
        if get_id_from_behavior(obj2.behavior) == id_bhvCreepyHouseDoor then
            local group2 = (obj2.oBehParams >> 24) & 0xFF
            if group == group2 then
                obj2.oAction = 1
                obj2.oTimer = 0
                network_send_object(obj2, true)
            end
        end
        obj2 = obj_get_next(obj2)
    end
end

function bhv_creepy_house_switch_loop(obj)
    local m = gMarioStates[0]

    if obj.oTimer == 1 then
        cur_obj_play_sound_2(SOUND_GENERAL2_PURPLE_SWITCH);
    end

    if obj.oTimer >= 30 then
        obj.oTimer = 30
        if m ~= nil and m.marioObj ~= nil and obj.oAction == 0 then
            if (m.action & ACT_FLAG_ATTACKING) ~= 0 and dist_between_objects(obj, m.marioObj) < 200 then
                obj.oAction = 1
                obj.oTimer = 0
                network_send_object(obj, true)
                if bhv_creepy_house_switch_all_on(obj) then
                    bhv_creepy_house_switch_open_doors(obj)
                end
            end
        end
    end

    local max_rot = 0x2500
    local speed = max_rot / 8
    if obj.oAction == 1 then
        if obj.oFaceAngleRoll < max_rot then
            obj.oFaceAngleRoll = obj.oFaceAngleRoll + speed
            if obj.oFaceAngleRoll >= max_rot then
                obj.oFaceAngleRoll = max_rot
            end
        end
    end
end

id_bhvCreepyHouseSwitch = hook_behavior(nil, OBJ_LIST_LEVEL, true, bhv_creepy_house_switch_init, bhv_creepy_house_switch_loop, 'id_bhvCreepyHouseSwitch')
