-- set boo star position
vec3f_set(gLevelValues.starPositions.BalconyBooStarPos, 14152.4, 2610, -6598.6)

LEVEL_CREEPY = LEVEL_BBH
local sSecretLocations = {}

function creepy_on_level_init()
    sSecretLocations = {}

    local obj = obj_get_first(OBJ_LIST_LEVEL)
    while obj ~= nil do
        if get_id_from_behavior(obj.behavior) == id_bhvHiddenStarTrigger then
            local vec = { x = obj.oPosX, y = obj.oPosY, z = obj.oPosZ }
            table.insert(sSecretLocations, vec)
        end
        obj = obj_get_next(obj)
    end
end

function creepy_collect_secret(m)
    local obj = obj_get_first(OBJ_LIST_LEVEL)
    while obj ~= nil do
        if get_id_from_behavior(obj.behavior) == id_bhvHiddenStarTrigger then
            local vec = { x = obj.oPosX, y = obj.oPosY, z = obj.oPosZ }
            if vec3f_dist(m.pos, vec) < 250 then
                obj.oPosX = m.pos.x
                obj.oPosY = m.pos.y
                obj.oPosZ = m.pos.z
            end
        end
        obj = obj_get_next(obj)
    end
end

function creepy_mario_update_local(m)
    if m.action == ACT_GROUND_POUND_LAND and m.prevAction == ACT_GROUND_POUND then
        for k, v in pairs(sSecretLocations) do
            if vec3f_dist(m.pos, v) < 250 then
                play_character_sound(m, CHAR_SOUND_OOOF2)
                drop_and_set_mario_action(m, ACT_FEET_STUCK_IN_GROUND, 0)
                creepy_collect_secret(m)
            end
        end
    elseif m.action == ACT_FEET_STUCK_IN_GROUND then
        local animFrame = m.marioObj.header.gfx.animInfo.animFrame
        if animFrame < 90 then
            set_anim_to_frame(m, 90)
        end

    end
end
