-- name: Creepy Canyon
-- description: A single-level casual rom hack with 7 stars.\nRequires at least two people to get one of the stars.\nRecommended to cap the player count at 2-4.
-- incompatible: romhack

smlua_text_utils_course_acts_replace(COURSE_BBH, " 5 CREEPY CANYON", "THE CLIFF'S EDGE", "RED COIN REPOSESSION", "THE GRAVEROBBER'S SECRETS", "THE CAP SHOP", "COMBING THE CATACOMBS", "HAUNTED HOUSE ON THE HILL")

-- use fixed collisions
gLevelValues.fixCollisionBugs = 1

local sSyncValidTimer = 0

local sOnLevelInit = {
    [LEVEL_CREEPY] = creepy_on_level_init
}

local sOnMarioUpdateLocal = {
    [LEVEL_CREEPY] = creepy_mario_update_local
}

function on_level_init()
    local np = gNetworkPlayers[0]
    local func = sOnLevelInit[np.currLevelNum]
    if func then func() end
end

function on_sync_valid()
    sSyncValidTimer = 5
    -- TEMPORARY
    save_file_set_flags(SAVE_FLAG_HAVE_VANISH_CAP)
end

function mario_update_local(m)
    local np = gNetworkPlayers[0]
    local func = sOnMarioUpdateLocal[np.currLevelNum]
    if func then func(m) end
    if sSyncValidTimer > 0 then
        sSyncValidTimer = sSyncValidTimer - 1
        if sSyncValidTimer <= 0 then
            if gNetworkPlayers[0].currLevelNum ~= LEVEL_CREEPY then
                warp_to_level(LEVEL_CREEPY, 1, 1)
                return
            end
        end
    end
end

function mario_update(m)
    if m.playerIndex == 0 then
        mario_update_local(m)
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)
hook_event(HOOK_ON_LEVEL_INIT, on_level_init)
hook_event(HOOK_ON_SYNC_VALID, on_sync_valid)